import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;

import pl.postivo.api.webservices_php.DispatchReturnObject;
import pl.postivo.api.webservices_php.DocumentFile;
import pl.postivo.api.webservices_php.Option;
import pl.postivo.api.webservices_php.PostivoPlBindingStub;
import pl.postivo.api.webservices_php.PostivoPlLocator;
import pl.postivo.api.webservices_php.Recipient;
import pl.postivo.api.webservices_php.Shipment;


public class Dispatch {

	public static void main(String[] args) {
	//  Przykad wywoania metody dispatch, umoliwiajcej wysanie nowej przesyki
        try
        {
            String sLogin = ""; // Login konta w pl
            String sApiPass = ""; // Haso dostpu do konta przez API
            String iMsgType = "1"; // Typ przesyki (1-przesyka listowa, 2-Fax)

            //DOKUMENTY

            //Obiekt zawierajcy zawarto pliku z dokumentami 
            DocumentFile document = new DocumentFile();

            File file = new File("C:\\Nazwa_Pliku.pdf");
            byte[] docByte = getBytesFromFile(file);
            
            String imgString =  new sun.misc.BASE64Encoder().encode(docByte);

            document. setFile_name("Nazwa_Pliku.pdf");
            document.setFile_stream(imgString) ;

            // Tablica zawierajca zawarto plikw z dokumetnami, ktre powinny by umieszczone
            // w przesyce (Mozna podac wiele plikw jako kolejne elementy tablicy)
            DocumentFile[] arDocFiles = new DocumentFile[] { document };

            //ODBIORCY

            // Dane odbiorcw podane bezporednio:
            Recipient recipment_1 = new Recipient();
            recipment_1.setId(0);
            recipment_1.setSource("inline") ;
            recipment_1.setRecipient_name("Jan Nowak") ;
            recipment_1.setRecipient_address_prefix("ul.");
            recipment_1.setRecipient_address("Przykadowa") ;
            recipment_1.setRecipient_home_number("2");
            recipment_1.setRecipient_flat_number("5");
            recipment_1.setRecipient_post_code("00-999");
            recipment_1.setRecipient_city("Warszawa");
            recipment_1.setRecipient_fax_number("000000000");

            // Odbiorcy z grupy odbiorcw
            Recipient recipment_2 = new Recipient();
            recipment_2.setSource("group");
            recipment_2.setId(1);

            // Odbiorca z ksizki adresowej
            Recipient recipment_3 = new Recipient();
            recipment_3.setSource("book");
            recipment_3.setId(1);

            // Tablica zawierajca dane odbiorcw przesyek
            Recipient[] arRecipients = new Recipient[] { recipment_1, recipment_2, recipment_3 };

            //PARAMETRY PRZESYKI

            // ID nadawcy przesyki
            Option option_1 = new Option();
            option_1.setName("sender_id");
            option_1.setValue("19");

            // ID profilu uytej konfiguracji
            Option option_2 = new Option();
            option_2.setName("config_id");
            option_2.setValue("30");

            // data (w przypadku faksw rwnie godzina i minuta) nadania przesyki
            Option option_3 = new Option();
            option_3.setName("dispatch_date");
            option_3.setValue("2011-02-21");

            // Tablica zawierajca parametry przesyki
            Option[] arDispatchOptions = new Option[] { option_1, option_2, option_3 };

            // Utworzenie obiektu stub:
            PostivoPlLocator locator = new PostivoPlLocator();	 
         	PostivoPlBindingStub stub =(PostivoPlBindingStub)locator.getPostivoPlPort(new java.net.URL("http://api.postivo.pl/webservices.php"));

            // Wywoanie metody dispatch z przekazaniem wszystkich parametrw
            DispatchReturnObject output = stub.dispatch(sLogin, sApiPass, iMsgType, arDocFiles, arRecipients, arDispatchOptions);

            //DANE WYJCIOWE

            // Przykad obsugi danych wyjciowych:
            System.out.println("Status dania: " + output.getResult());
            System.out.println("Kod statusu dania: " + output.getResult_code());
            System.out.println("Opis statusu dania: " + output.getResult_description());

            for (Shipment shipment : output.getShipments())
            {

                System.out.println("Id przesyki: " + shipment.getId());
                System.out.println("Przesyka dla: " + shipment.getRecipient_name() + ", " + shipment.getRecipient_address() + " " + shipment.getRecipient_home_number() + " " + shipment.getRecipient_flat_number() + ", " + shipment.getRecipient_post_code() + " " + shipment.getRecipient_city() + ", fax: " + shipment.getRecipient_fax_number());
            	System.out.println("skadajca si z: " + shipment.getPage_number() + " stron ma status " + shipment.getStatus() + "(kod statusu: " + shipment.getStatus_code() + " opis kodu: " + shipment.getStatus_description());

                if (shipment.getStatus().equals("OK"))
                {
                    System.out.println("Zostanie nadana za porednictwem: " + shipment.getDispatch_carrier() + " jako: " + shipment.getDispatch_type() + ". Jej koszt to " + shipment.getPrice() + "z netto");
                }
            }
        }
        catch (Exception exeption)
        {
            System.out.println("Wystpi bd: " + exeption.getMessage());
        }

	}
	
	public static byte[] getBytesFromFile(File file) throws IOException {
        InputStream is = new FileInputStream(file);
    
        long length = file.length();
    
        if (length > Integer.MAX_VALUE) {
        }
    
        byte[] bytes = new byte[(int)length];
    
        int offset = 0;
        int numRead = 0;
        while (offset < bytes.length
               && (numRead=is.read(bytes, offset, bytes.length-offset)) >= 0) {
            offset += numRead;
        }
    
        if (offset < bytes.length) {
            throw new IOException("Could not completely read file "+file.getName());
        }
    
        is.close();
        return bytes;
    }

}
