import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;

import pl.postivo.api.webservices_php.DocumentFile;
import pl.postivo.api.webservices_php.PostivoPlBindingStub;
import pl.postivo.api.webservices_php.PostivoPlLocator;
import pl.postivo.api.webservices_php.PriceReturnObject;
import pl.postivo.api.webservices_php.Recipient;
import pl.postivo.api.webservices_php.ShipmentPrice;


public class Price {

	public static void main(String[] args) {
		// Przykad wywoania metody getPrice, umoliwiajcej sprawdzenie kosztu przesyki
        try
        {
            String sLogin = ""; // Login konta w pl
            String sApiPass = ""; // Haso dostpu do konta przez API
            String iMsgType = "1"; // Typ przesyki (1-przesyka listowa, 2-Fax)

            //DOKUMENTY

            //Obiekt zawierajcy zawarto pliku z dokumentami 
            DocumentFile document = new DocumentFile();

            File file = new File("C:\\Nazwa_Pliku.pdf");
            byte[] docByte = getBytesFromFile(file);
            
            String imgString =  new sun.misc.BASE64Encoder().encode(docByte);

            document. setFile_name("Nazwa_Pliku.pdf");
            document.setFile_stream(imgString) ;

            // Tablica zawierajca zawarto plikw z dokumetnami, ktre powinny by umieszczone
            // w przesyce (Mozna podac wiele plikw jako kolejne elementy tablicy)
            DocumentFile[] arDocFiles = new DocumentFile[] { document };

            //ODBIORCY

            // Dane odbiorcw podane bezporednio:
            Recipient recipment_1 = new Recipient();
            recipment_1.setId(0);
            recipment_1.setSource("inline") ;
            recipment_1.setRecipient_name("Jan Nowak") ;
            recipment_1.setRecipient_address_prefix("ul.");
            recipment_1.setRecipient_address("Przykadowa") ;
            recipment_1.setRecipient_home_number("2");
            recipment_1.setRecipient_flat_number("5");
            recipment_1.setRecipient_post_code("00-999");
            recipment_1.setRecipient_city("Warszawa");
            recipment_1.setRecipient_fax_number("000000000");

            // Odbiorcy z grupy odbiorcw
            Recipient recipment_2 = new Recipient();
            recipment_2.setSource("group");
            recipment_2.setId(1);

            // Odbiorca z ksizki adresowej
            Recipient recipment_3 = new Recipient();
            recipment_3.setSource("book");
            recipment_3.setId(1);

            // Tablica zawierajca dane odbiorcw przesyek
            Recipient[] arRecipients = new Recipient[] { recipment_1, recipment_2, recipment_3 };

            //PARAMETRY PRZESYKI

          // ID profilu konfiguracji (0 - konfiguracja domylna - najtasza)
            int iConfId = 0;

            // Utworzenie obiektu stub:
            PostivoPlLocator locator = new PostivoPlLocator();	 
         	PostivoPlBindingStub stub =(PostivoPlBindingStub)locator.getPostivoPlPort(new java.net.URL("http://api.postivo.pl/webservices.php"));

            // Wywoanie metody getPrice z przekazaniem wszystkich parametrw
            PriceReturnObject output = stub.getPrice(sLogin, sApiPass, iMsgType, arDocFiles, arRecipients, iConfId);

            //DANE WYJCIOWE

            // Przykad obsugi danych wyjciowych:
            System.out.println("Status dania: " + output.getResult());
            System.out.println("Kod statusu dania: " + output.getResult_code());
            System.out.println("Opis statusu dania: " + output.getResult_description());

            for (ShipmentPrice shipment : output.getShipments_price())
            {

                System.out.println("Przesyka dla: " + shipment.getRecipient_name() + ", " + shipment.getRecipient_address() + " " + shipment.getRecipient_home_number() + " " + shipment.getRecipient_flat_number() + ", " + shipment.getRecipient_post_code() + " " + shipment.getRecipient_city() + ", fax: " + shipment.getRecipient_fax_number());
                System.out.println("Zostanie nadana za porednictwem: " + shipment.getDispatch_carrier() + " jako: " + shipment.getDispatch_type() + ". Jej koszt to " + shipment.getPrice() + "z netto");
            }
        }
        catch (Exception exeption)
        {
            System.out.println("Wystpi bd: " + exeption.getMessage());
        }

	}
	
	public static byte[] getBytesFromFile(File file) throws IOException {
        InputStream is = new FileInputStream(file);
    
        long length = file.length();
    
        if (length > Integer.MAX_VALUE) {
        }
    
        byte[] bytes = new byte[(int)length];
    
        int offset = 0;
        int numRead = 0;
        while (offset < bytes.length
               && (numRead=is.read(bytes, offset, bytes.length-offset)) >= 0) {
            offset += numRead;
        }
    
        if (offset < bytes.length) {
            throw new IOException("Could not completely read file "+file.getName());
        }
    
        is.close();
        return bytes;
    }

}
